import hashlib
try:
    import xbmcgui
    import xbmc
except:
    from dev.xbmclib import xbmcgui
    from dev.xbmclib import xbmc

class XBMCPlayer(xbmc.Player):
    id = None
    callback = None
    starttime = None
    totalTime = None
    currentTime = None
    currentMedia = None
    
    onPlayBackPausedCB = None
    onPlayBackResumedCB = None
    onPlayBackEndedCB = None
    onPlayBackStoppedCB = None
    onPlayBackStartedCB = None
    
    def __init__(self, *args, **kwargs):
        xbmc.Player.__init__(self)
        self.id = kwargs.get("id",None)
        self.callback = kwargs.get("callback",None)
        if self.id != None:
            self.id = hashlib.sha1(self.id).hexdigest()
            
    def __del__(self):
        self.onPlayBackStopped()
        if self.id != None and self.currentMedia != None and self.totalTime != None and self.currentTime != None:
            if self.currentTime/(self.totalTime/100) > 90 or True: #count only playback greater 90%
                try:
                    if self.callback != None:
                        self.callback(id=self.id,media=self.currentMedia,total=self.totalTime,current=self.currentTime)
                except:
                    pass
        
    def play(self, *args, **kwargs):
        xbmc.Player.play(self,*args,**kwargs)
        while self.isPlaying():
            xbmc.sleep(100)
            try:
                currentTime = self.getTime();
                if currentTime != None:
                    self.currentTime = currentTime
            except:
                pass
        xbmc.sleep(500)
            
    def onPlayBackStarted(self,cb=None):
        try:
            self.currentMedia = self.getPlayingFile()
            self.totalTime = self.getTotalTime()
            if self.id == None and self.currentMedia != None:
                self.id = hashlib.sha1(self.currentMedia).hexdigest()
        except:
            pass
        if cb != None:
            self.onPlayBackStartedCB = cb
            return None
        elif self.onPlayBackStartedCB != None:    
            self.onPlayBackStartedCB()
        #print ">>>onPlayBackStarted>>>>>>>>>>> %s %s %s" %(self.totalTime,self.currentTime,self.currentMedia)
        
    def onPlayBackPaused(self,cb=None):
        #print ">>>onPlayBackPaused>>>>>>>>>>> %s %s %s" %(self.totalTime,self.currentTime,self.currentMedia)
        if cb != None:
            self.onPlayBackPausedCB = cb
            return None
        elif self.onPlayBackPausedCB != None:    
            self.onPlayBackPausedCB()
        pass
        
    def onPlayBackResumed(self,cb=None):
        #print ">>>onPlayBackResumed>>>>>>>>>>> %s %s %s" %(self.totalTime,self.currentTime,self.currentMedia)
        if cb != None:
            self.onPlayBackResumedCB = cb
            return None
        elif self.onPlayBackResumedCB != None:    
            self.onPlayBackResumedCB()
        pass
    
    def onPlayBackEnded(self,cb=None):
        #print ">>>onPlayBackEnded>>>>>>>>>>> %s %s %s" %(self.totalTime,self.currentTime,self.currentMedia)
        if cb != None:
            self.onPlayBackEndedCB = cb
            return None
        elif self.onPlayBackEndedCB != None:    
            self.onPlayBackEndedCB()
        pass
    
    def onPlayBackStopped(self,cb=None):
        #print ">>>onPlayBackStopped>>>>>>>>>>> %s %s %s" %(self.totalTime,self.currentTime,self.currentMedia)
        if cb != None:
            self.onPlayBackStoppedCB = cb
            return None
        elif self.onPlayBackStoppedCB != None:    
            self.onPlayBackStoppedCB()
        pass
    
    def getPlayingFile(self):
        if self.isPlaying() == True:
            return xbmc.Player.getPlayingFile(self)
        return self.currentMedia
    
    def getTotalTime(self):
        if self.isPlaying() == True:
            return xbmc.Player.getTotalTime(self)
        return self.totalTime
        
    def getTime(self):
        if self.isPlaying() == True:
            return xbmc.Player.getTime(self)
        return self.currentTime
    
    def isWatched(self):
        return (self.currentTime/(self.totalTime/100) > 90)
    
    