import sys, os
try:
    import xbmc
except:
    from dev.xbmclib import *
from lib import IPhoenix

class IVideo(IPhoenix):
    __homePath = None
    
    title = None
    thumbnail = "icon.png"
    fanart = "fanart.jpg"
    isSearchable = False
    
    def __init__(self,homePath):
        IPhoenix.__init__(self)
        self.__homePath = homePath
        
    
    def getDirectory(self,path="",args={}):
        """ 
            path == "" return full index 
            path == "mycategory1/categorey2/A-Z/A" return singel category contents
            args hold additional arguments in a dictionary
        """
        raise NotImplementedError("getDirectory(self,path)")
    
    def formatTitle(self,title,metaInfo):
        return title
    
    def search(self,searchstring):
        raise NotImplementedError("search(self,searchstring)")
    
    """### HELPER FUNCTIONALITY BEGIN """
    def setTitle(self,title):
        self.title = title
        
    def getTitle(self):
        return self.title
    
    def setThumbnail(self,tumbnail):
        self.thumbnail = tumbnail
    
    def getThumbnail(self):
        thumb = xbmc.translatePath(os.path.join(self.__homePath,self.thumbnail))
        if os.path.exists(thumb):
            return thumb
        else:
            return None
    
    def getFanArt(self):
        fanart = xbmc.translatePath(os.path.join(self.__homePath,self.fanart))
        if os.path.exists(fanart):
            return fanart
        else:
            return None
        
    def setFanArt(self,fanart):
        self.fanart = fanart
        
    def getType(self):
        return "video"
