import re
import urllib
from resolver import IResolver, HosterException, IPBlockedException, StreamOfflineException
from lib.BeautifulSoup import BeautifulStoneSoup
from lib.FormParser import getFormFields
from lib import JSUnpacker

class Hoster(IResolver):
    domain = "2gb-hosting.com"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/videos/([^&|^\/|^\?|^\.]+)|[\?|\&]+v=([^&|^\/|^\?|^\.]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://www.%s/videos/%s/.html"%(self.domain,self.getMID()))
            else:
                raise HosterException("mid not found 0x0")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/videos/%s/.html" % (self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)
            form = s("form",limit=1)
            if len(form) > 0:
                formFields = getFormFields(form)
                response = self.opener.open("http://www.%s/videos/%s/.html" % (self.domain,self.getMID()),urllib.urlencode(formFields))
                html = response.read()
                lunpacked = JSUnpacker.extract(html)
                # TODO: Write generic resolver for JWPlayer settings and use it eg.: lib.JWPlayer.getFile..
                if len(lunpacked) > 0:
                    unpacked = lunpacked[0]
                    if "jwplayer(" in unpacked:
                        m = re.search('''['|"]*file['|"]*\s*:\s*['|"](.*?)['|"]\s*''', unpacked.replace("\\'","'"), re.I + re.DOTALL)
                        if m:
                            return m.group(1)
                        else:
                            raise HosterException('0x3 not resovlable')
                    else:
                        raise HosterException('0x2 not resovlable')
                else:
                    raise HosterException('0x1 not resovlable')
            elif "Video not found" in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException as e:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
