from resolver import IResolver, HosterException, IPBlockedException, StreamOfflineException
from lib.FormParser import getFormFields
from lib.BeautifulSoup import BeautifulStoneSoup
import urllib, re


# TODO: Check for 1hr limit reached and give user feedback if limit is reached  
class Hoster(IResolver):
    domain = "bitshare.com"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/?f=([\w]+)|/files/([\w]+)/',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://%s/?f=%s"%(self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            self.setCookie("language_selection", "EN")
            response = self.opener.open("http://%s/?f=%s"%(self.domain,self.getMID()))
            html = response.read()
            m = re.compile('var ajaxdl = "([\w]+)";',re.I).findall(html)
            if len(m)>0:
                ajaxdl = ''.join(map(str,m[0]))
            elif "File not available" in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException("no ajaxdl found")
            self.addHeaders(('X-Requested-With','XMLHttpRequest'),('Referer','%s' %self.getURL()))
            self.opener.open("http://%s/files-ajax/%s/request.html" % (self.domain,self.getMID()), urllib.urlencode({ "request":"generateID", "ajaxid": ajaxdl}))
            html.replace("<noscript>","").replace("</noscript>","")
            init = BeautifulStoneSoup(html)
            iframe = init.findAll("iframe",attrs={"src" : re.compile(".*\.recaptcha.\.*")})
            if(len(iframe)>0):
                src = iframe[0]["src"]
                response = self.opener.open(src)
                html = response.read()
                s = BeautifulStoneSoup(html)
                captcha = s("img")
                form = s("form",limit=1)
                if len(captcha)>0 and len(form)>0:
                    formFields = getFormFields(form)
                    response = self.getCaptchaCode(("http://www.google.com/recaptcha/api/%s" % captcha[0]["src"]))
                    if response != None:
                        formFields["recaptcha_response_field"]=response
                        response = self.opener.open(src,
                                        urllib.urlencode(formFields))
                        html = response.read()
                        s = BeautifulStoneSoup(html)
                        success = s(text=re.compile("Your answer was correct",re.I))
                        if len(success)>0:
                            textarea = s("textarea")
                            if len(textarea) > 0:
                                token = s("textarea")[0].contents[0]
                                form = init("form",limit=1)
                                if len(form)>0:
                                    formFields = getFormFields(form)
                                    formFields["recaptcha_challenge_field"] = token
                                    formFields["recaptcha_response_field"] = "manual_challenge"
                                    formFields["submit"] = "submit"
            
            self.opener.open("http://%s/files-ajax/%s/request.html" % (self.domain,self.getMID()), urllib.urlencode({ "request":"validateCaptcha", "ajaxid": ajaxdl, "recaptcha_challenge_field":formFields["recaptcha_challenge_field"],"recaptcha_response_field":formFields["recaptcha_response_field"]}))
            response = self.opener.open("http://%s/files-ajax/%s/request.html" % (self.domain,self.getMID()), urllib.urlencode({ "request":"getDownloadURL", "ajaxid": ajaxdl}))
            ajaxresponse = response.read()
            m = re.compile('ERROR#(.*)',re.I).findall(ajaxresponse)
            if len(m)>0:
                msg = ''.join(map(str,m[0]))
                raise HosterException('Error: %s' % msg)
            m = re.compile('SUCCESS#(.*)',re.I).findall(ajaxresponse)
            if len(m)>0:
                return ''.join(map(str,m[0]))
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException:
            raise
        except IPBlockedException:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))