import re
import urllib, urllib2
from resolver import IResolver, HosterException, StreamOfflineException
from lib.BeautifulSoup import BeautifulStoneSoup


class Hoster(IResolver):
    domain = "blip.tv"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/play/([^&|^\/|^\?|^\.]+)|/rss/flash/([0-9]+)|-([0-9]+)$',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
            elif("/file/" in url):
                response = self.opener.open(url)
                res_url = response.geturl()
                m = re.compile('/play/([^&|^\/|^\?|^\.]+)|/rss/flash/([0-9]+)|-([0-9]+)$',re.I).findall(res_url)
                if len(m)>0:
                    self.setMID(''.join(map(str,m[0])))
                    self.setURL(res_url)
                else:
                    raise HosterException("mid not found 0x1")
            else:
                raise HosterException("mid not found 0x0")
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException("%s init failed: %s" % (self.domain,e))
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolveRSS(self,url):
        response = self.opener.open(url)
        html = response.read()
        s = BeautifulStoneSoup(html)
        media = s.channel.item.findAll('media:content')
        if len(media)>0:
            for m in media:
                if(m['blip:role'].lower() == 'web' or
                   m['blip:role'].lower() == 'source'):
                    return m['url']
            raise HosterException('0x2 not resovlable')
        else:
            raise HosterException('0x1 not resovlable')

    def resolve(self):
        try:
            if("/play/" in self.getURL()):
                response = self.opener.open("http://%s/play/%s" % (self.domain,self.getMID()))
                res_url = response.geturl()
                data=re.compile('file=(.*?)&',re.I).findall(res_url)
                if len(data)>0:
                    return self.resolveRSS(urllib.unquote(data[0]))
                else:
                    raise HosterException('0x0 not resovlable')
            else:
                return self.resolveRSS("http://%s/rss/flash/%s" % (self.domain,self.getMID()))
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
