import urllib, urllib2
from resolver.Resolver import Resolver 
from resolver import IResolver, HosterException, StreamOfflineException
from lib.FormParser import *

class Hoster(IResolver):
    domain = "crypt2.net"
    dbname = "crypt2net.db"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/file/([^&|^\/|^\?|^\.]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://%s/file/%s" % (self.domain,self.getMID()))
            else:
                raise HosterException("mid not found 0x0")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))
        
    def initDatabase(self, cursor):
        IResolver.initDatabase(self, cursor)
        cursor.execute('CREATE TABLE IF NOT EXISTS lookup (mid UNIQUE, url);')
        
    def lookupUrl(self,mid):
        cur = self.getDBCursor()
        cur.execute("select url FROM lookup WHERE mid=?", (mid,))
        urlrow = cur.fetchone()
        if urlrow != None:
            #print ">>> cachedurl: %s" % urlrow[0]
            return urlrow[0]
        return None
    
    def cacheUrl(self,mid,url):
        cur = self.getDBCursor()
        cur.execute('INSERT INTO lookup (mid, url) VALUES (?,?)',(mid,url))
        #print ">>> cached: mid:%s url:%s" % (mid,url)

    def resolve(self):
        try:
            url = self.lookupUrl(self.getMID())
            if url != None:
                return Resolver(url).getStream()
            
            response = self.opener.open("http://%s/file/%s" % (self.domain,self.getMID()))
            html = response.read()
            html.replace("<noscript>","").replace("</noscript>","")
            init = BeautifulStoneSoup(html)
            iframe = init("iframe")
            if(len(iframe)>0) and self.domain in response.geturl():
                src = iframe[0]["src"]
                if "/recaptcha/" in src:
                    response = self.opener.open(src)
                    html = response.read()
                    s = BeautifulStoneSoup(html)
                    captcha = s("img")
                    form = s("form",limit=1)
                    if len(captcha)>0 and len(form)>0:
                        formFields = getFormFields(form)
                        response = self.getCaptchaCode(("http://www.google.com/recaptcha/api/%s" % captcha[0]["src"]))
                        if response != None:
                            formFields["recaptcha_response_field"]=response
                            response = self.opener.open(src,
                                            urllib.urlencode(formFields))
                            html = response.read()
                            s = BeautifulStoneSoup(html)
                            success = s(text=re.compile("Your answer was correct",re.I))
                            if len(success)>0:
                                textarea = s("textarea")
                                if len(textarea) > 0:
                                    token = s("textarea")[0].contents[0]
                                    form = init("form",limit=1)
                                    if len(form)>0:
                                        formFields = getFormFields(form)
                                        formFields["recaptcha_challenge_field"] = token
                                        formFields["recaptcha_response_field"] = "manual_challenge"
                                        formFields["submit"] = "submit"
                                        response = self.opener.open("http://%s/file/%s" % (self.domain,self.getMID()),urllib.urlencode(formFields))
                                        html = response.read()
                                        s = BeautifulStoneSoup(html)
                                        iframe = s("iframe")
                                        if(len(iframe)>0) and self.domain in response.geturl():
                                            src = iframe[0]["src"]
                                            if not self.domain in src:
                                                streamurl = Resolver(src).getStream()
                                                self.cacheUrl(self.getMID(), src)
                                                return streamurl
                                            else:
                                                raise HosterException('0x7 not resovlable')
                                        elif not self.domain in src:
                                            streamurl = Resolver(src).getStream()
                                            self.cacheUrl(self.getMID(), src)
                                            return streamurl
                                        else:
                                            raise HosterException('0x6 not resovlable')
                                    else:
                                        raise HosterException('0x5 not resovlable')
                                else:
                                    raise HosterException('0x4 not resovlable')
                            else:
                                # try again on error
                                return self.resolve()
                        else:
                            return None
                    else:
                        raise HosterException('0x2 not resovlable')
                elif not self.domain in src:
                    streamurl = Resolver(src).getStream()
                    self.cacheUrl(self.getMID(), src)
                    return streamurl
                else:
                    raise HosterException('0x1 not resovlable')
            elif not self.domain in response.geturl():
                url = response.geturl()
                streamurl = Resolver(url).getStream()
                self.cacheUrl(self.getMID(), url)
                return streamurl
            elif "This link could not be found!" in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))
        except StreamOfflineException as e:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))