from resolver import IResolver
import vidxden_com

# Old address and still in use so just map into new plugin for backwards compatibility
class Hoster(IResolver):
    newDomain = "vidxden.com"
    domain = "divxden.com"
    hoster = None
    
    def __init__(self, *args, **kwargs):
        IResolver.__init__(self, *args, **kwargs)
        if not kwargs.get("url") == None:
            kwargs["url"] = kwargs["url"].replace(self.domain,self.newDomain)
        self.hoster = vidxden_com.Hoster(*args, **kwargs)
        
    def parseURL(self, url):
        url = url.replace(self.domain,self.newDomain)
        self.hoster.parseURL(url)
        self.setMID(self.hoster.getMID())
        self.setURL(self.hoster.getURL())
        
        
    def resolve(self):
        return self.hoster.resolve()