import re
import urllib, urllib2
from resolver import IResolver, HosterException, StreamOfflineException


class Hoster(IResolver):
    domain = "video.google.com"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('docid=([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://%s/videoplay?docid=%s&hl=en" % (self.domain,self.getMID()))
            value = response.read()
            data=re.compile('preview_url:\'(.*?)\'',re.I).findall(value)
            if len(data)>0:
                data=re.compile('videoUrl\\\\x3d(.*?)\\\\x26',re.I).findall(data[0].replace(",","%2C"))
                if len(data)>0:
                    return urllib.unquote(data[0]).replace(",","%2C")
                else:
                    raise HosterException('0x0 not resovlable')
            else:
                raise HosterException('0x1 not resovlable')
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
