import urllib
import urllib2
from resolver import IResolver, HosterException, StreamOfflineException
from lib.FormParser import *


class Hoster(IResolver):
    domain = "movshare.net"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/video/([^&|^\/|^\?]+)|v=([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://www.%s/video/%s" % (self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))
        
    def getContent(self,url,postdata=None):
        try:
            if postdata == None:
                return self.opener.open(url)
            return self.opener.open(url,postdata)
        except urllib2.HTTPError, e:
            if e.getcode() == 500 and not "http://www2." in url:
                return self.getContent(url.replace("www.","").replace("http://","http://www2."),postdata)          
            raise

    def resolve(self):
        try:
            response = self.getContent("http://www.%s/video/%s" % (self.domain,self.getMID()))
            self.addHeader("Referer","http://www.%s/video/%s" % (self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)            
            form = s("form",attrs={"id":"watch"})
            if(len(form)>0):
                formFields = getFormFields(form)
                response = self.getContent("http://www.%s/video/%s" % (self.domain,self.getMID()),
                                        urllib.urlencode(formFields))
                html = response.read()
                html = html.replace("\n","").replace("\n","")
                m = re.compile('filekey\s*=\s*[\"|\'](.*?)[\"|\']',re.I).findall(html)
                if(len(m)>0):
                    filekey = m[0]
                    response = self.getContent("http://www.%s/api/player.api.php?%s" % (self.domain,urllib.urlencode({
                        'file':self.getMID(),
                        'user':'undefined',
                        'key':filekey,
                        'pass':'undefined',
                        'codes':'undefined'
                    })))
                    html = response.read()
                    m = re.compile("(http[s]{0,1}://.*\.%s\/dl\/[^&]*)" % self.domain,re.I).findall(html)
                    if(len(m)>0):
                        return m[0]
                    else:
                        raise HosterException('0x2 not resovlable')
                else:
                    raise HosterException('0x1 not resovlable')
            elif "This file no longer exists on our servers." in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException as e:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
