import re
from urllib import urlencode
from urlparse import parse_qs
from resolver import IResolver, HosterException, StreamOfflineException

class Hoster(IResolver):
    domain = "novamov.com"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/file/([^&|^\/|^\?]+)|/video/([^&|^\/|^\?]+)|[\&|\?]v=([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://www.%s/file/%s"%(self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/file/%s" % (self.domain,self.getMID()))
            html = response.read()
            m = re.findall('filekey\s*\=[\"|\'](.*?)[\"|\']', html, re.I + re.M + re.DOTALL)
            if len(m) > 0:                
                response = self.opener.open("http://www.%s/api/player.api.php?%s" % (self.domain, urlencode({
                           "codes":"1",
                           "key":m[0],
                           "user":self.getUsername("undefined"),
                           "pass":self.getPassword("undefined"),
                           "file":self.getMID()
                })))
                ret = response.read().replace("\n","").replace("\r","")
                data = parse_qs(ret)
                return data["url"][0]
            elif "This file no longer exists on our servers" in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))