import urllib
from resolver import IResolver, HosterException, StreamOfflineException
from lib.FormParser import *


class Hoster(IResolver):
    domain = "putlocker.com"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/file/([^&|^\/|^\?]+)|/embed/([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://www.%s/file/%s"%(self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/file/%s" % (self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)
            forms = s("form",attrs={"method":"post"})
            if(len(forms)>0):
                freeform = None
                for form in forms:
                    if form.get("action",None) == None:
                        freeform = form
                        break
                if freeform != None:
                    formFields = getFormFields(freeform)
                    response = self.opener.open("http://www.%s/file/%s" % (self.domain,self.getMID()),
                                        urllib.urlencode(formFields))
                    html = response.read()
                    m = re.compile('playlist\s*:\s*[\"|\'](.*?)[\"|\']',re.I).findall(html)
                    if(len(m)>0):
                        response = self.opener.open("http://www.%s%s" % (self.domain,m[0]))
                        html = response.read()
                        s = BeautifulStoneSoup(html)
                        media = s(attrs={"url":re.compile("^http",re.I)})
                        if(len(media)>0):
                            return media[0]["url"]
                        else:
                            raise HosterException('0x3 not resovlable')
                    elif "currently not available" in html:
                        s = BeautifulStoneSoup(html)
                        link = s("a",attrs={"href":re.compile("^\/get_file\.php",re.I)})
                        if len(link) > 0:
                            return self.opener.open("http://www.%s%s" % (self.domain,link[0]["href"])).geturl()
                        else:
                            raise HosterException('0x4 not resovlable')
                    else:
                        raise HosterException('0x2 not resovlable')
                else:
                    raise HosterException('0x1 not resovlable')
            elif "This file doesn't exist, or has been removed." in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException as e:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
