import re
from resolver import IResolver, HosterException, IPBlockedException, StreamOfflineException
from lib.BeautifulSoup import BeautifulStoneSoup

class Hoster(IResolver):
    domain = "sevenload.com"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/videos/([\w]+)|/pl/([\w]+)/',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://www.%s/videos/%s"%(self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://flash.%s/player?itemId=%s" % (self.domain,self.getMID()))
            xml = response.read()
            soup = BeautifulStoneSoup(xml)
            if soup.streams:
                result = soup.streams.findAll("stream",attrs={"quality" : re.compile(".+")})
                if len(result) > 0:
                    options = []
                    result = sorted(result, key=lambda dat: int(dat["width"]), reverse=True) #sort by width best qylity first
                    for node in result:
                        options.append("Quality: %s %s (%sx%s)"%(node["quality"].capitalize(),node["codec"],node["width"],node["height"]))
                    sel = self.getUserSelection(options)
                    if sel > -1:
                        return result[sel].find("location").text
                    else:
                        return None
                else:
                    raise HosterException('0x1 not resovlable')
            elif soup.playerconfig.error:
                if int(soup.playerconfig.error["code"]) == 44:
                    raise StreamOfflineException("The requested stream is offline.")
                else:
                    raise HosterException('0x0 not resovlable')
        except StreamOfflineException as e:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))