import urllib
import re
from resolver import IResolver, HosterException, StreamOfflineException
from lib.FormParser import getFormFields

class Hoster(IResolver):
    domain = "streamcloud.eu"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('\/([^&|^\/|^\?|^\.]+)\/',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://%s/%s/.html" % (self.domain,self.getMID()))
            else:
                raise HosterException("mid not found 0x0")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))
        
    def resolve(self):
        try:
            response = self.opener.open("http://%s/%s/.html" % (self.domain,self.getMID()))
            html = response.read().replace("\n","").replace("\r","")
            
            m = re.findall("(<form.*?</form>)",html,re.I+re.M+re.DOTALL)
            if len(m) > 0:
                formFields = getFormFields(m[0])
                formFields["referer"]=""
                # wait 10 sek to get jwplayer src
                if self.showWaitDialog(10,self.domain):
                    response = self.opener.open("http://%s/%s/.html" % (self.domain,self.getMID()), urllib.urlencode(formFields))
                    html = response.read()
                    # TODO: Write generic resolver for JWPlayer settings and use it eg.: lib.JWPlayer.getFile..
                    if "jwplayer(" in html:
                        m = re.search('''['|"]*file['|"]*\s*:\s*['|"](.*?)['|"]\s*''', html.replace("\n","").replace("\r",""), re.I + re.DOTALL + re.M)
                        if m:
                            return m.group(1)
                        else:
                            raise HosterException('0x2 not resovlable')
                    else:
                        raise HosterException('0x1 not resovlable')
                else:
                    #user canceled
                    return None
            elif "File Not Found" in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException as e:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))