import re
import urllib2
from resolver import IResolver, HosterException, StreamOfflineException
from lib.BeautifulSoup import BeautifulStoneSoup


class Hoster(IResolver):
    domain = "viddler.com"
    apiKey = "tg50w8nr11q8176liowh"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/embed/([^&|^\/|^\?|^\.]+)|/file/([^&|^\/|^\?|^\.]+)|/player/([^&|^\/|^\?|^\.]+)|/v/([^&|^\/|^\?|^\.]+)',re.I).findall(url)
            if len(m)>0:
                # set mid
                self.setMID(''.join(map(str,m[0])))
                # set clean url
                self.setURL("http://www.%s/file/%s"%(self.domain,self.getMID()))
            else:
                response = self.opener.open(url)
                url = response.geturl()
                m = re.compile('/embed/([^&|^\/|^\?|^\.]+)|/file/([^&|^\/|^\?|^\.]+)|/player/([^&|^\/|^\?|^\.]+)|/v/([^&|^\/|^\?|^\.]+)',re.I).findall(url)
                if len(m)>0:
                    # set mid
                    self.setMID(''.join(map(str,m[0])))
                    # set clean url
                    self.setURL("http://www.%s/file/%s"%(self.domain,self.getMID()))
                else:
                    raise HosterException("mid not found")
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException("%s init failed: %s" % (self.domain,e))
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/api/v2/viddler.videos.getDetails.xml?key=%s&video_id=%s" % (self.domain,self.apiKey ,self.getMID()))
            xml = response.read()
            s = BeautifulStoneSoup(xml)
            files = s.video.files.findAll("file")
            return files[0].url.contents[0]
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
