import re
import urllib
from resolver import IResolver, HosterException, StreamOfflineException
from lib import JSUnpacker
from lib.BeautifulSoup import BeautifulStoneSoup 
from lib.FormParser import getFormFields

class Hoster(IResolver):
    domain = "vidxden.com"
    
    # http://www.vidxden.com/5qc3dnyaz58d
    # http://www.vidxden.com/embed-5qc3dnyaz58d-width-653-height-362.html
    
        
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('//.*/embed\-([^&|^\/|^\?|^\-]+)|//.*/([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                self.setMID(''.join(map(str,m[0])))
                self.setURL("http://www.%s/%s"%(self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))
    
    
    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/%s"%(self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)            
            form = s("form",limit=1)
            if(len(form)>0):
                formFields = getFormFields(form)
                formFields["referer"]=""
                formFields["method_free"]="Continue to Video"
                response = self.opener.open("http://www.%s/%s" % (self.domain,self.getMID()),
                                        urllib.urlencode(formFields))
                html = response.read()
                unpacked = JSUnpacker.extract(html)
                if len(unpacked) > 0:
                    clean = unpacked[0].replace("\\","")
                    m = re.findall("addVariable\(\s*['|\"]file['|\"]\s*\,\s*['|\"](.*?)['|\"]\s*\)",clean,re.I + re.DOTALL)
                    if len(m) > 0:
                        return str(m[0])
                    else:
                        raise HosterException('0x2 not resovlable')
                else:
                    raise HosterException('0x1 not resovlable')
            elif "No such file or the file has been removed due to copyright infringement issues" in html:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                raise HosterException('0x0 not resovlable')
        except StreamOfflineException:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))
            
        