import re
import urllib2
from resolver import IResolver, HosterException, IPBlockedException, StreamOfflineException
from lib.BeautifulSoup import BeautifulStoneSoup


class Hoster(IResolver):
    domain = "vimeo.com"

    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('/video/([^&|^\/|^\?]+)|/([0-9]+)',re.I).findall(url)
            if len(m)>0:
                # set mid
                self.setMID(''.join(map(str,m[0])))
                # set clean url
                self.setURL("http://%s/%s"%(self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            self.addHeaders(('X-Requested-With','XMLHttpRequest'),('Referer',"http://%s/%s"% (self.domain,self.getMID())))
            response = self.opener.open("http://%s/%s?action=download" % (self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)
            lis = s.findAll('li')
            if len(lis)>0:
                options = []
                selection = []
                for li in lis:
                    meta = re.findall("([0-9]+)x([0-9]+)\s*/\s*([0-9|G|M|B]+)",li.span.text,re.I + re.M);
                    if meta:
                        selection.append({
                                        "location":"http://%s%s"%(self.domain,li.a["href"]),
                                        "width":int(meta[0][0]),
                                        "height":int(meta[0][1]),
                                        "size":str(meta[0][2]),
                                        "quality":li.a.text
                                      })
                selection = sorted(selection, key=lambda dat: dat["width"], reverse=True)
                for node in selection:
                    options.append("Quality: %s (%sx%s) %s"%(node["quality"].capitalize(),node["width"],node["height"],node["size"]))
                sel = self.getUserSelection(options)
                if sel > -1:
                    return self.opener.open(selection[sel]["location"]).geturl()
                else:
                    return None

            else:
                raise HosterException('0x0 not resovlable')
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))
        except IPBlockedException:
            raise
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
