import re
import urllib
import urllib2
from resolver import IResolver, HosterException, StreamOfflineException
from lib.BeautifulSoup import BeautifulStoneSoup


class Hoster(IResolver):
    domain = "youtube.com"
    
    def parseURL(self, url):
        IResolver.parseURL(self, url)
        try:
            m = re.compile('v=([^&|^\/|^\?]+)|video_id=([^&|^\/|^\?]+)|/v/([^&|^\/|^\?]+)|/embed/([^&|^\/|^\?]+)',re.I).findall(url)
            if len(m)>0:
                # set mid
                self.setMID(''.join(map(str,m[0])))
                # set cleaned url
                self.setURL("http://www.%s/watch?v=%s" % (self.domain,self.getMID()))
            else:
                raise HosterException("mid not found")
        except Exception as e:
            raise HosterException("%s init failed: %s" % (self.domain,e))

    def resolve(self):
        try:
            response = self.opener.open("http://www.%s/watch?v=%s" % (self.domain,self.getMID()))
            html = response.read()
            s = BeautifulStoneSoup(html)
            embed = s("script",text=re.compile("url_encoded_fmt_stream_map"),linit=1)
            if (len(embed) > 0):
                data=re.compile('url_encoded_fmt_stream_map(.*?)\\u0026amp;',re.I).findall(embed[0])
                if len(data) > 0:
                    data=re.compile('url=(.*?)&quality=(.*?)',re.I).findall(urllib.unquote(data[0]))
                    if len(data) > 0:
                        return urllib.unquote(data[0][0])
                    else:
                        raise HosterException('0x2 not resovlable')
                else:
                    raise HosterException('0x1 not resovlable')
            else:
                raise HosterException('0x0 not resovlable')
        except urllib2.HTTPError as e:
            if e.code == 404:
                raise StreamOfflineException("The requested stream is offline.")
            else:
                HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))
        except Exception as e:
            raise HosterException('%s not resovlable => mid:%s msg:%s' % (self.domain, self.getMID(), e))

    
